add rescue, fix default pxe, ubuntu locale
[automated-distro-installer] / myfai-chboot-local
index 35331b3f9f880aa787361eedfe611ab33b9d18e0..f21a837dc5308790c45b263c3e69aaa3dd37006c 100755 (executable)
@@ -3,11 +3,18 @@
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
+fai_action_arg=I
+fai_reboot_arg=,reboot
 case $1 in
     -h|--help)
         echo "see help from myfai-chboot"
         exit 0
         ;;
+    -S)
+        fai_action_arg=S
+        fai_reboot_arg=
+        shift
+        ;;
 esac
 
 [[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
@@ -17,9 +24,29 @@ e() { echo "$@"; "$@"; }
 host=$1
 
 type -t host &>/dev/null || apt-get -y install dnsutils
-ip=$(host $host | sed -rn 's/^\S+ has address //p;T;q')
-gateway_ip=$(route -n | sed -rn 's/^0\.0\.0\.0\s+(\S+).*/\1/p')
-my_ip=$(host faiserver $gateway_ip | sed -rn 's/^\S+ has address //p;T;q')
+gateway_if=$(ip route | sed -rn 's/^default via \S+ dev (\S+) .*/\1/p')
+if [[ ! $gateway_if ]]; then
+    echo "$0: failed to find gateway interface"
+    exit 1
+fi
+# assuming ipv4, or else we might need to deal with multiple addresses
+# in an ipv4 + ipv6 network.
+network=$(ip -4 -o a show dev $gateway_if | sed -rn '/scope.*global/s/^(\S+\s+){3}(\S+)\s.*/\2/p')
+if [[ ! $network ]]; then
+    echo "$0: failed to find network"
+    exit 1
+fi
+my_ip=${network%/*}
+if [[ $host == default ]]; then
+    ip=$network
+else
+    ip=$(host $host | sed -rn 's/^\S+ has address //p;T;q')/32
+fi
+
+
+# alternate way of getting my ip
+#gateway_ip=$(ip route | sed -rn 's/^default via (\S+) .*/\1/p')
+#my_ip=$(host faiserver $gateway_ip | sed -rn 's/^\S+ has address //p;T;q')
 
 if modprobe nfsd &>/dev/null; then
     std_arg="-u nfs://faiserver/srv/fai/config"
@@ -28,8 +55,8 @@ if modprobe nfsd &>/dev/null; then
     # I restrict it to one ip as simple but imperfect access control.
     sed -ri --follow-symlinks '\%^/srv/fai/%d' /etc/exports
     cat >>/etc/exports <<EOF
-/srv/fai/config $ip/32(async,ro,no_subtree_check)
-/srv/fai/nfsroot $ip/32(async,ro,no_subtree_check,no_root_squash)
+/srv/fai/config $ip(async,ro,no_subtree_check)
+/srv/fai/nfsroot $ip(async,ro,no_subtree_check,no_root_squash)
 EOF
     exportfs -ra
 else
@@ -51,7 +78,7 @@ fi
 
 # man page doesn't explain this, but this deletes & thus disables
 # all chboot systems.
-e fai-chboot -Iv $std_arg default # set it to default to get a val out of it next
+e fai-chboot -${fai_action_arg}v $std_arg default # set it to default to get a val out of it next
 kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
 default_k_args=$(fai-chboot -L '^default$' | \
                      sed -r "s/^(\S+\s+){3}(.*)/\2/")
@@ -67,4 +94,4 @@ for arg in $default_k_args; do
     esac
 done
 rm -f /srv/tftp/fai/pxelinux.cfg/*
-e fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt,reboot $std_arg $kernel "$host"
+e fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"